package ie.tcd.scss.cs4032.websocketsT1;

import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.websockets.DataFrame;
import com.sun.grizzly.websockets.WebSocket;
import com.sun.grizzly.websockets.WebSocketApplication;
import com.sun.grizzly.websockets.WebSocketListener;

import java.io.IOException;

/**
 * Basic Echo Server through websocket
 * 
 * @author Oscar Cassetti
 * 
 */
public class EchoApplication extends WebSocketApplication {

	@Override
	public WebSocket createSocket(WebSocketListener... listeners)
			throws IOException {
		final EchoWebSocket socket = new EchoWebSocket(listeners);
		return socket;
	}

	@Override
	public void onConnect(WebSocket socket) {
		this.add(socket);

		for (WebSocket webSocket : getWebSockets()) {
			if (!webSocket.equals(socket)) {
				try {
					webSocket.send("New Client Joins ");
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	@Override
	public void onMessage(WebSocket socket, DataFrame frame) throws IOException {
		final String data = frame.getTextPayload();
		for (WebSocket webSocket : getWebSockets()) {
			try {
				webSocket.send(frame);
				webSocket.send(data + " MANIPULATED BY SERVER");
			} catch (IOException e) {
				e.printStackTrace();
				webSocket.close();
			}
		}
	}

	@Override
	public boolean isApplicationRequest(Request arg0) {

		System.err.println("ARG0  ===> " + arg0.getRemotePort());
		return true;
	}

}
