package ie.tcd.scss.cs4032.websocketsT1;

import static org.junit.Assert.fail;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import local.ws.client.WebSocketClient;
import local.ws.client.WebSocketMessageListener;

import org.junit.Test;



public class WSTest {
   private URI wsURI ;
   private WebSocketMessageListener messageListener ;
   
	public WSTest() {
		 try {
			this.wsURI = new URI("wss://localhost:8181/wst1/echo");
		} catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//Set up the virtual machine variables with our trustStore since we 
		// have self-signed certificates 
		//http://confluence.atlassian.com/display/JIRA/Connecting+to+SSL+services
		//http://blogs.sun.com/andreas/entry/no_more_unable_to_find
		//http://db.apache.org/derby/docs/dev/adminguide/cadminsslclient.html
		
		// This didn't work,  I got an exception: 
		// Keystore was tampered with, or password was incorrect
		// So I am going to set up this outside. This works  
		//-Djavax.net.ssl.trustStore=/home/oscar/myKeyStore.jks 
		//-Djavax.net.ssl.trustStorePassword=qwerty
		
		//System.setProperty("javax.net.ssl.trustStore", "/home/oscar/myKeyStore.jks");
		//System.setProperty("javax.net.ssl.trustStorePassword", "querty");
	
		this.messageListener = new WSTestListner();
	}

	@Test
	public void testConnect(){
        WebSocketClient ws = new WebSocketClient(wsURI);
        try {
			ws.connect();
		} catch (IOException e) {
			
			e.printStackTrace();
			fail(e.getCause().toString());
		}finally{
			try {
				ws.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}
	/**
	 * Try to send a string to the server
	 * the server should reply the string back
	 */
	@Test
	public void testSend(){
        WebSocketClient ws = new WebSocketClient(wsURI);
        try {
			ws.connect();
		} catch (IOException e) {
			e.printStackTrace();
			fail(e.getCause().toString());
		}
		ws.addListener(messageListener);
		try {
			ws.send("AVAILABLE");
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	
		
		try {
			ws.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	//In order to run this outside maven
	//-Djavax.net.ssl.trustStore=/home/oscar/myKeyStore.jks 
	//-Djavax.net.ssl.trustStorePassword=qwerty
	public static void main(String[] args){
		WSTest wsTest = new WSTest() ;
		wsTest.testConnect();
		wsTest.testSend();
	}
}
